'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _core = require('@babel/core');

var _pluginSyntaxTypescript = require('@babel/plugin-syntax-typescript');

var _pluginSyntaxTypescript2 = _interopRequireDefault(_pluginSyntaxTypescript);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line
exports.default = (code, { eventPath, plugin, filename }) => {
  if (!plugin || !plugin.plugin) {
    throw new Error('required plugin');
  }

  const opts = plugin.plugin;
  const fromOpts = { from: eventPath };

  const lastPlugin = Array.isArray(opts) ? [opts[0], _extends({}, opts[1], fromOpts)] : [opts, fromOpts];

  const { code: result } = (0, _core.transform)(code, {
    filename,
    babelrc: false,
    plugins: [_pluginSyntaxTypescript2.default, lastPlugin]
  });

  return {
    code: result ? result.trim() : '',
    meta: {
      handlerName: 'typescript',
      pluginName: typeof lastPlugin[0] === 'string' ? lastPlugin[0] : ''
    }
  };
};